package de.twomartens.oparlservice.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.*;

@Builder
@Getter
@ToString
@EqualsAndHashCode
@AllArgsConstructor(access = AccessLevel.PRIVATE)
@NoArgsConstructor(force = true, access = AccessLevel.PRIVATE)
@JsonInclude(JsonInclude.Include.NON_NULL)
public class ErrorObject {
    @Schema(description = "URL to type specification")
    private final String type = "https://schema.oparl.org/1.1/Error";

    @Schema(description = "message for display to the user")
    private final String message;

    @Schema(description = "additional information about the error")
    private final String debug;
}
