package de.twomartens.oparlservice.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.*;

import java.util.List;

@Builder
@Getter
@ToString
@EqualsAndHashCode
@AllArgsConstructor(access = AccessLevel.PRIVATE)
@NoArgsConstructor(force = true, access = AccessLevel.PRIVATE)
@JsonInclude(JsonInclude.Include.NON_NULL)
public class ObjectList<T> {
    @NonNull
    @Schema(description = "contains list of objects", required = true)
    private final List<T> data;

    @NonNull
    @Schema(description = "contains information about pagination", required = true)
    private final Pagination pagination;

    @NonNull
    @Schema(description = "contains links related to this list", required = true)
    private final Links links;
}
