package de.twomartens.oparlservice.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.*;

@Builder
@Getter
@ToString
@EqualsAndHashCode
@AllArgsConstructor(access = AccessLevel.PRIVATE)
@NoArgsConstructor(force = true, access = AccessLevel.PRIVATE)
@JsonInclude(JsonInclude.Include.NON_NULL)
public class Pagination {
    @Schema(description = "specifies total number of objects in the list", nullable = true)
    private final int totalElements;

    @Schema(description = "specifies the number of objects per list page", nullable = true)
    private final int elementsPerPage;

    @Schema(description = "specifies the current page number in the list", nullable = true)
    private final int currentPage;

    @Schema(description = "specifies the total number of pages in the list", nullable = true)
    private final int totalPages;
}
