package de.twomartens.oparlservice.service;

import de.twomartens.oparlservice.configs.OParlServiceProperties;
import io.micrometer.core.instrument.Counter;
import io.micrometer.core.instrument.MeterRegistry;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

@Slf4j
@Service
public class GreetingService {

  private final MeterRegistry meterRegistry;
  private final OParlServiceProperties properties;
  private final Counter counter;

  public GreetingService(MeterRegistry meterRegistry, OParlServiceProperties properties) {
    this.meterRegistry = meterRegistry;
    this.properties = properties;
    counter = meterRegistry.counter("infodb.callCounter");
  }

  public String createGreeting(String name) {
    log.info("Create greeting for '{}'", name);
    counter.increment();
    meterRegistry.gauge("infodb.nameLength", name.length());
    String greeting = properties.getTemplate().getGreeting();
    return String.format(greeting, name);
  }
}
