package de.twomartens.oparlservice.service;

import de.twomartens.oparlservice.configs.OParlServiceProperties;
import io.micrometer.core.instrument.simple.SimpleMeterRegistry;
import org.assertj.core.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.Mock;
import org.mockito.junit.jupiter.MockitoExtension;

import static org.mockito.BDDMockito.given;

@ExtendWith(MockitoExtension.class)
class GreetingServiceTest {

  private GreetingService service;

  @Mock
  private OParlServiceProperties properties;

  @Mock
  private OParlServiceProperties.Template template;

  @BeforeEach
  void beforeEach() {
    given(template.getGreeting()).willReturn("Hello %s");
    given(properties.getTemplate()).willReturn(template);
    service = new GreetingService(new SimpleMeterRegistry(), properties);
  }

  @Test
  void createGreeting() {
    String result = service.createGreeting("Test");
    Assertions.assertThat(result).isEqualTo("Hello Test");
  }
}
